jvx.volume

## Class PwTex2Cubes

- java.lang.Object
- - jv.object.PsObject
  - - jvx.project.PjWorkshop
    - - jvx.volume.PwTex2Cubes

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, PsUpdateIf, PjWorkshopIf

      public class PwTex2Cubes
      extends PjWorkshop

  Tex2Cubes Workshop.
  See Also:
    Serialized Form
  Author:
    Matthias Nieser
  Version:
    09.03.15, 2.00 revised (kp) Moved to jvx.volume from dev.volume.
    01.06.2010, 1.00 created (mn)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `EDGE_INTERSECTION`
    `static int` | `FACE_INTERSECTION`
    `static int` | `INSIDE_TETRAHEDRON`
    `PgPolygonSet` | `m_polygonSet` A Polygon Set to visualize the grid edges found in the texture data.
    `PgPolygonSet` | `m_polygonSetCleaned` Another Polygon Set to visualize the grid edges found in the texture data.
    `static int` | `VERTEX_GRID_POINT`

    - ### Fields inherited from class jv.object.PsObject

      `HAS_BOUNDARY_PANEL, HAS_CONFIG_PANEL, HAS_INFO_PANEL, HAS_LABEL_PANEL, HAS_MATERIAL_PANEL, HAS_TEXTURE_PANEL, HAS_VECTOR_PANEL, INSPECTOR_INFO, INSPECTOR_INFO_EXT, IS_DELETED, IS_FIXED, IS_FOCUSSED, IS_PICKED, IS_SELECTED, IS_USED, NUM_TAGS`

    - ### Fields inherited from interface jv.project.PjWorkshopIf

      `MODE_BUG, MODE_STANDARD, MODE_VALIDATE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PwTex2Cubes()` Construct a new PwTex2Cubes.
    `PwTex2Cubes(PgTetraSet geom)` Construct a new PwTex2Cubes from a given geometry.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getName()` Get the name of the workshop.
    `static void` | `guessElements(PgElementSet elementSet, PgPolygonSet polygonSet)` Add elements to elementSet - these should build the level surfaces.
    `void` | `init()` Initializes the workshop.
    `static PgElementSet` | `makeIsoSurface(PgTetraSet geom, PdVector[][] tex, double textureIsoValue)`
    `static PgElementSet` | `makeIsoSurface(PgTetraSet geom, PiVector[][] tex, int quantization, double textureIsoValue)`
    `static PiVector[][]` | `quantizeTexture(PdVector[][] tex, int quantization)` Quantize given texture coordinates to integer textures.
    `void` | `readMatchingsFromField()` Import frame rotation information from Vector Field "matching".
    `PgElementSet` | `remesh()` Creates a cube set from the texture coordinates.
    `static PgElementSet` | `remesh(PgTetraSet geom, PdVector[][] tex, boolean showOuterPlanes)`
    `static PgElementSet` | `remesh(PgTetraSet geom, PiVector[][] coords, int quant)` Creates a cube set from the texture coordinates.
    `PgElementSet` | `remesh2()` Compute an elementSet containing the level surfaces of a 3D texture on a PgTetraSet.
    `void` | `setDisplay(PvDisplayIf display)` Set the active display when this workshop was launched.
    `void` | `setGeometry(PgGeometry geom)` Set the geometry.
    `void` | `setMatching(PiVector[][] matching)` Set rotation information for transition between tetrahedra and their neighbours.
    `void` | `setTextures(PdVector[][] tex)` Set double textures and quantize to integer by a default quantization.
    `void` | `setTextures(PiVector[][] coords, int quantization)` Set quantized texture coordinates and quantization factor.
    `void` | `shiftTextures()` Shift all texture coordinates by half quantization.
    `boolean` | `update(java.lang.Object event)` Update the class whenever a child has changed.

    - ### Methods inherited from class jvx.project.PjWorkshop

      `cancel, close, getDisplay, getDisplays, getGeometry, getMode, getSavedGeometry, getViewer, isModal, isStandalone, ok, removeGeometry, reset, setDisplays, setModal, setMode, setStandalone, setViewer`

    - ### Methods inherited from class jv.object.PsObject

      `addInspector, addUpdateListener, assureInspector, clearTag, clone, clone, clone, copy, getFather, getInfoPanel, getInspector, getNumObjects, getSymbol, hasInspector, hasTag, hasUpdateListener, instanceOf, instanceOf, newInspector, newInspector, removeInspector, removeInspector, removeUpdateListener, setName, setParent, setSymbol, setTag, toString, updatePanels`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.object.PsUpdateIf

      `getFather, setParent`

- - ### Field Detail

    - #### m_polygonSet

          public PgPolygonSet m_polygonSet

      A Polygon Set to visualize the grid edges found in the texture data.

    - #### m_polygonSetCleaned

          public PgPolygonSet m_polygonSetCleaned

      Another Polygon Set to visualize the grid edges found in the texture data.

    - #### VERTEX_GRID_POINT

          public static final int VERTEX_GRID_POINT

      See Also:
        Constant Field Values

    - #### EDGE_INTERSECTION

          public static final int EDGE_INTERSECTION

      See Also:
        Constant Field Values

    - #### FACE_INTERSECTION

          public static final int FACE_INTERSECTION

      See Also:
        Constant Field Values

    - #### INSIDE_TETRAHEDRON

          public static final int INSIDE_TETRAHEDRON

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PwTex2Cubes

          public PwTex2Cubes()

      Construct a new PwTex2Cubes.

    - #### PwTex2Cubes

          public PwTex2Cubes(PgTetraSet geom)

      Construct a new PwTex2Cubes from a given geometry.
      Parameters:
        `geom` - Geometry to work on.

  - ### Method Detail

    - #### init

          public void init()

      Initializes the workshop.
      Overrides:
        `init` in class `PjWorkshop`

    - #### setGeometry

          public void setGeometry(PgGeometry geom)

      Set the geometry.
      Specified by:
        `setGeometry` in interface `PjWorkshopIf`
      Overrides:
        `setGeometry` in class `PjWorkshop`
      Parameters:
        `geom` - the workshop modifies this geometry.

    - #### setDisplay

          public void setDisplay(PvDisplayIf display)

      Set the active display when this workshop was launched.
      Specified by:
        `setDisplay` in interface `PjWorkshopIf`
      Overrides:
        `setDisplay` in class `PjWorkshop`

    - #### update

          public boolean update(java.lang.Object event)

      Update the class whenever a child has changed. Method is usually invoked from the children.
      Specified by:
        `update` in interface `PsUpdateIf`
      Overrides:
        `update` in class `PjWorkshop`
      Parameters:
        `event` - sender of this update.
      Returns:
        true if update was correctly handled by superclass.
      See Also:
        `PsObject.setParent(PsUpdateIf)`, `PsObject.getFather()`, `PsObject.addUpdateListener(PsUpdateIf)`

    - #### getName

          public java.lang.String getName()

      Get the name of the workshop.
      Specified by:
        `getName` in interface `PsUpdateIf`
      Overrides:
        `getName` in class `PsObject`

    - #### setTextures

          public void setTextures(PiVector[][] coords,
                                  int quantization)

      Set quantized texture coordinates and quantization factor.

    - #### shiftTextures

          public void shiftTextures()

      Shift all texture coordinates by half quantization.

    - #### remesh

          public static PgElementSet remesh(PgTetraSet geom,
                                            PiVector[][] coords,
                                            int quant)

      Creates a cube set from the texture coordinates.

    - #### remesh

          public static PgElementSet remesh(PgTetraSet geom,
                                            PdVector[][] tex,
                                            boolean showOuterPlanes)

    - #### remesh

          public PgElementSet remesh()

      Creates a cube set from the texture coordinates.

    - #### makeIsoSurface

          public static PgElementSet makeIsoSurface(PgTetraSet geom,
                                                    PdVector[][] tex,
                                                    double textureIsoValue)

    - #### makeIsoSurface

          public static PgElementSet makeIsoSurface(PgTetraSet geom,
                                                    PiVector[][] tex,
                                                    int quantization,
                                                    double textureIsoValue)

    - #### setMatching

          public void setMatching(PiVector[][] matching)

      Set rotation information for transition between tetrahedra and their neighbours.

    - #### quantizeTexture

          public static PiVector[][] quantizeTexture(PdVector[][] tex,
                                                     int quantization)

      Quantize given texture coordinates to integer textures.

    - #### setTextures

          public void setTextures(PdVector[][] tex)

      Set double textures and quantize to integer by a default quantization.

    - #### readMatchingsFromField

          public void readMatchingsFromField()

      Import frame rotation information from Vector Field "matching". created from PgParamGeom3D.loadCache() method (ur).

    - #### remesh2

          public PgElementSet remesh2()

      Compute an elementSet containing the level surfaces of a 3D texture on a PgTetraSet.
      Author:
        Ulrich Reitebuch
      Version:
        26.08.10, 1.00 created (ur)

    - #### guessElements

          public static void guessElements(PgElementSet elementSet,
                                           PgPolygonSet polygonSet)

      Add elements to elementSet - these should build the level surfaces. In this method, elements are constructed from the edges given by m_polygonSet, quads and triangles in these edges are added.
      Author:
        Ulrich Reitebuch
      Version:
        03.09.10, 1.00 created (ur)

"

The software JavaView? is copyright protected. All Rights Reserved.
"